export function openThem({ it, scrollToId }: { it: string; scrollToId?: string }) {
  const gotoandopen = (_event: React.MouseEvent<HTMLElement, MouseEvent>) => {
    if (typeof window !== 'undefined') {
      console.log(`Opening tab: ${it}`);
      updateTabs(it, scrollToId);

      // Update der URL
      const newUrl = `?tab=${it}`;
      console.log(`Updating URL to: ${newUrl}`);
      window.history.pushState({ tab: it }, '', newUrl);
  /*     if (scrollToId && document.getElementById(scrollToId)) {
        const scElement = document.getElementById(scrollToId);
        if (scElement) {
            const scrollPos = window.innerHeight / 2 - scElement.offsetHeight / 2;
            window.scrollTo({ top: scrollPos, behavior: 'smooth' });
        }
      } */
      // Scrollen in die Mitte
     /*  const midScrollPosition = window.innerHeight / 2; // Berechnung der Mitte des Viewports
      console.log(`Scrolling to middle position: ${midScrollPosition}`); */
     /*  window.scrollTo({ top: midScrollPosition, behavior: 'smooth' }); */
    }
  };

  return gotoandopen;
}

function updateTabs(it: string, scrollToId?: string) {
  if (typeof window === 'undefined') return;

  let contenttabid = "tab-" + it;
  let parent = "parent-" + it;

  console.log(`Updating tabs for: ${it}`);

  // Verstecke alle Subtabs und Content-Tabs
  const subtabs = document.getElementsByClassName("sidesubtab");
  const contenttabs = document.getElementsByClassName("enginneeringtab");
  const sideitems = document.getElementsByClassName("sideitem");

  for (let i = 0; i < subtabs.length; i++) {
    (subtabs[i] as HTMLElement).style.display = "none";
    console.log(`Hiding subtab: ${subtabs[i].id}`);
  }
  for (let i = 0; i < contenttabs.length; i++) {
    (contenttabs[i] as HTMLElement).style.display = "none";
    console.log(`Hiding content tab: ${contenttabs[i].id}`);
  }
  for (let i = 0; i < sideitems.length; i++) {
    (sideitems[i] as HTMLElement)!.classList.remove("active-sideitem");
    console.log(`Removing active class from side item: ${sideitems[i].id}`);
  }

  // Zeige den aktuellen Tab und markiere das entsprechende Sidebar-Item
  document.getElementById(it)!.style.display = "block";
  console.log(`Showing tab: ${it}`);
  document.getElementById(parent)!.classList.add("active-sideitem");
  console.log(`Activating side item: ${parent}`);
  document.getElementById(contenttabid)!.style.display = "block";
  console.log(`Showing content tab: ${contenttabid}`);

  // Scrolle zu der angegebenen ID, falls vorhanden
  if (scrollToId) {
    const collapseElement = document.getElementById(scrollToId);
    if (collapseElement) {
        const elementTop = collapseElement.getBoundingClientRect().top + window.pageYOffset;
        const offset = window.innerHeight / 2 - collapseElement.offsetHeight / 2;
        const scrollPosition = elementTop - offset;

        window.scrollTo({
            top: scrollPosition,
            behavior: 'smooth',
        });
    }
}
/*   if (scrollToId && document.getElementById(scrollToId)) {
    const scElement = document.getElementById(scrollToId);
    if (scElement) {
        const scrollPos = window.innerHeight / 2 - scElement.offsetHeight / 2;
        window.scrollTo({ top: scrollPos, behavior: 'smooth' });
    }
  } */
}

// Füge einen Event Listener für `popstate` hinzu
if (typeof window !== 'undefined') {
  window.addEventListener('popstate', (event) => {
    console.log('Popstate event triggered');
    if (event.state) {
      const tab = event.state.tab;
      console.log(`Restoring tab: ${tab}`);
      updateTabs(tab);
      
      // Scrollen in die Mitte beim Zurücknavigieren
      console.log("Scrolling to middle on popstate...");
      const midScrollPosition = window.innerHeight / 2;
      window.scrollTo({ top: midScrollPosition, behavior: 'smooth' });
    } else {
      console.log("No state found in popstate event.");
    }
  });
}
